function  [Sm1, Sm2, dc, DV1, Level_1, Level_2]  = Distance_Control_0(Lv, Sm, SmC, Level_1, Level_2, dc, DV, Iout, T_PWM)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nc=length(DV)+1;            % Number of capacitors
m_max=2^nc;                 % Number of configurations
Sm1=zeros(1,nc);            % Configuration of the higher level H
Sm2=zeros(1,nc);            % Configuration of the lower level L
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Computation of the voltage deviation Delta_VH
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Dist=Inf;
DV1=DV;
for ii=1:m_max
    if Lv(ii)==Level_1
        DV0=DV-SmC(ii,:)*Iout*T_PWM*dc;
        Dist_ii=norm(DV0);
        if Dist_ii<Dist
            Dist=Dist_ii;  % Looking for min(Delta_VH)
            Sm1=Sm(ii,:);  % Configuration of the higher level H
            DV1=DV0;
        end
    end
end
DV=DV1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Computation of the voltage deviation Delta_VL
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Dist=Inf;
for ii=1:m_max
    if Lv(ii)==Level_2
        DV0=DV-SmC(ii,:)*Iout*T_PWM*(1-dc);
        Dist_ii=norm(DV0);
        if Dist_ii<Dist
            Dist=Dist_ii; % Looking for min(Delta_VL)
            Sm2=Sm(ii,:); % Configuration of the lower level L
            DV1=DV0;
        end
    end
end
return