function  [Sm1, Sm2, dc, DV1, Level_1, Level_2]  = Distance_Control_n(Lv, Sm, SmC, Level_1, Level_2, dc, DV, Iout, T_PWM, Ns, RV0)
dc0=dc;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nc=length(DV)+1;                            % Number of capacitors
m_max=2^nc;                                 % Number of configurations
m=max(Lv)+1;                                % Number of levels
ii_1 = 0;  
ii_2 = 0; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Computation of the voltage deviation Delta_V
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DV1=DV;
Dist=Inf;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Cycling from 1 to the maximum admissible level-to-level distance
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for Stp=1:Ns                             
    for kk=0:Stp-1
        Do_It=1;
        Stp0=Stp;
        if Level_1==Level_2
            Stp0=Stp-1;
        end
        Level_a=Level_1+kk;                 % New higher level H
        Level_b=Level_a-Stp0;               % New higher level L
        if Level_a==Level_b
            DuCy0=dc0;
        else
            DuCy0=(dc0+Stp0-1-kk)/Stp0;     % New duty-cycle
        end
        Level=[Level_a, Level_b];
        if (Level_a>=m)||(Level_b<0)      % The new levels must not exceed the maximum and minimum level boundaries
            Do_It=0;
        end
        DuCy=[DuCy0 (1-DuCy0)]*Iout*T_PWM;  % Fraction of PWM period in which the higher and lower levels are applied times Iout
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Computing Delta_V all possible combinations of Level H and Level L with the
        % current level-to-level distance "Stp0"
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%        
        if Do_It
            for ii=1:m_max
                for jj=1:m_max
                    if (Lv(ii)==Level(1))&&(Lv(jj)==Level(2))
                        DV0=DV-SmC(ii,:)*DuCy(1)-SmC(jj,:)*DuCy(2);
                        Dist_ii=norm(DV0);
                        if Dist_ii<Dist
                            Dist=Dist_ii;
                            ii_1=ii;
                            ii_2=jj;
                            dc=DuCy0(1);
                            DV1=DV0;
                        end
                    end
                end
            end
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Exiting conditions from the algorithm: 
    % 1) If the voltage trajectory move towards the desired voltage configuration point Vmk0; 
    % 1) If the voltage trajectory stays within an hypersphere (of size nc-1) with radius "RV0*Stp0"
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if (Dist<norm(DV))||(Dist<RV0*Stp)
        break
    end
end
Sm1=Sm(ii_1,:);                             % Configuration of the higher level H
Sm2=Sm(ii_2,:);                             % Configuration of the lower level L
return