

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function  [Xt,t] = GENERA_SEGNALE(Str,Par,New_Par)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin<3
    New_Par='';
end
%%%%%%  Parametri del sistema
for ii=1:length(Par{1}{1})
    Str1=Par{1}{1}{ii};
    if ~contains(Str1,';')
        Str1=[Str1 ';'];
    end
    eval(Str1);
end
%%%%%%%  Asse dei tempi
t=(0:1/Nr_Punti:1)*Tend;
%%%%%%%  Segnale temporale
Xt=0*t;
for jj=1:length(Str{1})
    Type=Str{1}{jj}{1};
    for ii=2:length(Str{1}{jj})
        Str1=Str{1}{jj}{ii};
        if ~contains(Str1,';')
            Str1=[Str1 ';'];
        end
        eval(Str1);
    end
    if not(isempty(New_Par))    %%%% Modifica di un parametro
        eval(New_Par)
    end
    switch Type
        case 'Constant'
            Xt1=Bias+0*t;
        case 'Sinusoidal'
            Xt1=Bias+A*sin(W*t+Ph);
        case 'Triangular'
            Shift=0;
            [Xt1,t] = TRIANGOLARE_SHIFT(Bias,A,W,Ph,t,Shift);
        case 'SawTooth'
            Shift=0.25;
            [Xt1,t] = TRIANGOLARE_SHIFT(Bias,A,W,Ph,t,Shift);
        case 'SawToothSh'
            [Xt1,t] = TRIANGOLARE_SHIFT(Bias,A,W,Ph,t,Shift);
        case 'SinConstSin'
            [Xt1,t] = SIN_CONST_SIN(Bias,A,Vd0,t,Frac,NrSin,NrShift);
    end
    Xt=Xt+Xt1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function  [Xt,t] = SIN_CONST_SIN(Bias,A,Vd0,t,Frac,NrSin,NrShift)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin<7
    NrShift=0;
end
Tfin=t(end);
t1=Tfin*Frac;
t2=Tfin*(1-Frac);
T=t1/NrSin;
W=2*pi/T;
t0=(0:0.001:1)*t1;
y_t0=Vd0-(Bias+A*sin(W*t0));
Ind_Ph=find(diff(sign(y_t0))~=0);
t3=t1-NrShift*T;
t4=t2-NrShift*T;
Ind_t1=find(t<=t3);
Ind_t2=find(t>=t4);
Ind_Const=setdiff(1:length(t),[Ind_t1 Ind_t2]);
Ph0=W*t0(Ind_Ph(1));
Xt=Bias+A*sin(W*t(Ind_t1)+Ph0);
Xt=[Xt t(Ind_Const)*0+Vd0];
Xt=[Xt Bias+A*sin(W*(t(Ind_t2)-t2)+Ph0)];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
return


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function  [Xt,t] = TRIANGOLARE_SHIFT(Bias,A,W,Ph,t,Shift)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ii_Range=-1:ceil(t(end)*W/(pi)+2);
Nr_Punti=length(ii_Range);
t_in=zeros(1,Nr_Punti);
y_in=zeros(1,Nr_Punti);
Shift=2*Shift-0.00001;
for ii=1:2:Nr_Punti
    t_in(ii)=-2.5+ii+Shift;
    y_in(ii)= 1;
    t_in(ii+1)=-1.5+ii-Shift;
    y_in(ii+1)=-1;
end
t_in=t_in*pi/W-Ph/W;
Xt=Bias+A*interp1(t_in,y_in,t);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
return
